import csv
from datetime import datetime
from datetime import timedelta
import numpy as np

def computeDiffInMonth(date1, date2):
   yearDiff = date1.year - date2.year
   monthDiff = date1.month - date2.month
   return yearDiff*12 + monthDiff

# get check in and checkout time from a file.
def getCinCoutFromFile(FileName):
   cin = []
   cout = []
   with open(FileName, 'rb') as csvfile:
      spamreader = csv.reader(csvfile, delimiter=',')
      row1 = next(spamreader) # thrown away first row.
      for row in spamreader:
         cout.append(datetime.strptime(row[1], '%Y-%m-%d %H:%M:%S'))
         cin.append(datetime.strptime(row[2], '%Y-%m-%d %H:%M:%S'))
   return cin, cout

DramaFname = []
DramaFname.append("./dataN/Drama/American_hustle.csv")
DramaFname.append("./dataN/Drama/Grand_Budapest_Hotel.csv") 
DramaFname.append("./dataN/Drama/great_Gatsby.csv")
DramaFname.append("./dataN/Drama/Silver_linings_playbook.csv")

FantasyFname = []
FantasyFname.append("./dataN/Fantasy/Cinderella.csv")
FantasyFname.append("./dataN/Fantasy/descendants.csv")
FantasyFname.append("./dataN/Fantasy/Frozen.csv")
FantasyFname.append("./dataN/Fantasy/Into_the_woods.csv")

HistoryFname = []
HistoryFname.append("./dataN/History/12_years_a_slave.csv")
HistoryFname.append("./dataN/History/imitation_game.csv")
HistoryFname.append("./dataN/History/kings_speech.csv")
HistoryFname.append("./dataN/History/Lincoln.csv")

ScifiFname=[]
ScifiFname.append("./dataN/Sci-fi/Gravity.csv")
ScifiFname.append("./dataN/Sci-fi/hunger_games.csv")
ScifiFname.append("./dataN/Sci-fi/Interstellar.csv")
ScifiFname.append("./dataN/Sci-fi/Star_trek_Into_darkness.csv")

BuckStart = datetime.strptime("2012-01-01 12:00:00", '%Y-%m-%d %H:%M:%S')
BuckEnd = datetime.strptime("2018-01-01 12:00:00", '%Y-%m-%d %H:%M:%S')
totalBucket = computeDiffInMonth(BuckEnd, BuckStart)

# total data_matrix, 
data_matrix = np.zeros([totalBucket, 22])
header = ('month,American_hustle,Grand_Budapest_Hotel,great_Gatsby,Silver_linings_playbook,TotalDrama,Cinderella,'
   'descendants,Frozen,Into_the_woods,TotalFantasy,12_years_a_slave,imitation_game,kings_speech,Lincoln,'
   'TotalHistory,Gravity,hunger_games,Interstellar,Star_trek_Into_darkness,TotalSciFi,AllTotal')



def CountTotalFourStuff(FnameList):
   CurData = np.zeros([totalBucket, 5]).astype(np.int32)
   for i in range(0, len(FnameList)):
      fname = FnameList[i]
      cinP, coutP = getCinCoutFromFile(fname)
      for j in xrange(0, len(coutP)):
         diffM = computeDiffInMonth(coutP[j], BuckStart)
         CurData[diffM, i] += 1
   CurData[:, 4] = np.sum(CurData[:, 0:4], axis=1)
   return CurData

def AggrerageBorrowTimeToMonth(Fname):
   cinP, coutP = getCinCoutFromFile(Fname)
   bucketList = []
   for i in range(0, totalBucket):
      TimeDiffList = []
      bucketList.append(TimeDiffList)
   for i in range(0, len(coutP)):
      diffM = computeDiffInMonth(coutP[i], BuckStart)
      bucketList[diffM].append(cinP[i] - coutP[i])
   return bucketList

def WiteAggreBorrowTimeToFile(bucketList, fname):
   totalRec = 0
   fout = open(fname, "w")
   for i in range(0, len(bucketList)):
      #Month
      fout.write("%d " % i)
      for Tdiff in bucketList[i]:
         fout.write("%d " % Tdiff.days)
         totalRec += 1
      fout.write("\n")
   fout.close()
   print("TotalRec: " + fname + " : " + str(totalRec))

def ComputeCheckPerMonthALL():
   data_matrix[:,0] = np.arange(0, totalBucket)
   data_matrix[:, 1:6] = CountTotalFourStuff(DramaFname)
   data_matrix[:, 6:11] = CountTotalFourStuff(FantasyFname)
   data_matrix[:, 11:16] = CountTotalFourStuff(HistoryFname)
   data_matrix[:, 16:21] = CountTotalFourStuff(ScifiFname)
   data_matrix[:, 21] = data_matrix[:,5] + data_matrix[:, 10] + data_matrix[:,15] + data_matrix[:,20]
   print(np.sum(data_matrix , axis=0))

   fout = open("./AllCheckPerMonth.csv", "w")
   fout.write("%s\n" % header)
   np.savetxt(fout, data_matrix, fmt='%d',delimiter=',')

def CompuetBorrowTimeMonthALL():
   for i in range(0,4):
      bucketList = AggrerageBorrowTimeToMonth(DramaFname[i])
      WiteAggreBorrowTimeToFile(bucketList, "./AggreratedDay/Drama%d.txt" % i)
      bucketList = AggrerageBorrowTimeToMonth(FantasyFname[i])
      WiteAggreBorrowTimeToFile(bucketList, "./AggreratedDay/Fantasy%d.txt" % i)
      bucketList = AggrerageBorrowTimeToMonth(HistoryFname[i])
      WiteAggreBorrowTimeToFile(bucketList, "./AggreratedDay/History%d.txt" % i)
      bucketList = AggrerageBorrowTimeToMonth(ScifiFname[i])
      WiteAggreBorrowTimeToFile(bucketList, "./AggreratedDay/Scifi%d.txt" % i)

CompuetBorrowTimeMonthALL()

'''
cinP, coutP = getCinCoutFromFile(DramaFname[0])


bucketList = []

averageBorrowInDays = np.zeros([totalBucket])

for i in xrange(0, totalBucket):
   TimeDiffList = []
   bucketList.append(TimeDiffList)

for i in xrange(0, len(coutP)):
   diffM = computeDiffInMonth(coutP[i], BuckStart)
   bucketList[diffM].append(cinP[i] - coutP[i])

totalRecord = np.zeros([totalBucket])

cumRecord = 0
for i in xrange(0, totalBucket):
   numRecords = len(bucketList[i])
   #print (numRecords)
   cumRecord += numRecords
print (cumRecord)
'''
'''
for i in xrange(0, totalBucket):
   numRecords = len(bucketList[i])
   totalRecord[i] = numRecords
   averageT = 0
   #if (numRecords != 0):
   #   averageT = min(bucketList[i]).days
   for Tdiff in bucketList[i]:
      averageT += Tdiff.days
   if (numRecords != 0):
      averageT /= numRecords
   #ri, averageT)
   averageBorrowInDays[i] = averageT

fout = open("./Star_trek_AveDays.txt", "w")
for i in xrange(0, totalBucket):
   fout.write("%d\n" % (int)(averageBorrowInDays[i]))
fout.close()
'''